// init.cpp

#include "state.h"

bool State::readFen(std::string fen)
{
    int  rank = RANK_8;
    int  file = FILE_A;
    int  pce = 0;
    int clor = 0;
    int  count = 0;
    int  sq64 = 0;

    int idx = 0;

    for (int i = 0; i < 64; ++i)
    {
        color[i] = init_empty[i];
        piece[i] = init_empty[i];
    }

    while (rank <= RANK_1 && fen.c_str()[idx] != ' ')
    {
        count = 1;
        char ch = fen.c_str()[idx++];
        switch (ch) {
        case 'p': pce = sP; clor = BLACK; break;
        case 'r': pce = sR; clor = BLACK; break;
        case 'n': pce = sN; clor = BLACK; break;
        case 'b': pce = sB; clor = BLACK; break;
        case 'k': pce = sK; clor = BLACK; break;
        case 'q': pce = sQ; clor = BLACK; break;
        case 'P': pce = sP; clor = WHITE; break;
        case 'R': pce = sR; clor = WHITE; break;
        case 'N': pce = sN; clor = WHITE; break;
        case 'B': pce = sB; clor = WHITE; break;
        case 'K': pce = sK; clor = WHITE; break;
        case 'Q': pce = sQ; clor = WHITE; break;

        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
            pce = EMPTY;
            count = ch - '0';
            break;

        case '/':
        case ' ':
            rank++;
            file = FILE_A;
            continue;

        default:
            std::cout << "Fen error: " << fen;
            return false;
        }

        for (int i = 0; i < count; i++) {
            sq64 = rank * 8 + file;
            if (pce != EMPTY)
            {
                piece[sq64] = pce;
                color[sq64] = clor;
            }
            file++;
        }
    }

    idx++;

    assert(fen.c_str()[idx] == 'w' || fen.c_str()[idx] == 'b');

    side = (fen.c_str()[idx++] == 'w') ? WHITE : BLACK;
    xside = (side == WHITE) ? BLACK : WHITE;
    castle = 0;

    idx++;

    int k = 0;
    while ( k < 4)
    {
        if (fen.c_str()[idx] == ' ')
        {
            break;
        }
        switch (fen.c_str()[idx++])
        {
        case 'K': castle |= WKCA; break;
        case 'Q': castle |= WQCA; break;
        case 'k': castle |= BKCA; break;
        case 'q': castle |= BQCA; break;
        default:	     break;
        }
    }

    idx++;

    ep = -1; // NOSQ

    if (fen.c_str()[idx] != '-')
    {
        file = fen.c_str()[idx++] - 'a';
        rank = 7 - (fen.c_str()[idx++] - '1');

        assert(file >= FILE_A && file <= FILE_H);
        assert(rank >= RANK_8 && rank <= RANK_1);

        ep = FR2SQ(file, rank);
    }

    ply = 0;
    hply = 0;

    first_move[0] = 0;

    set_hash();

    return true;
}
