// state.cpp

#include "state.h"

State::State()
  : side(WHITE)
  , xside(BLACK)
  , castle(0)
  , ep(NOSQ)
  , fifty(0)
  , hash(0)
  , ply(0)
  , hply(0)
{
}

State::State(const State &old)
  : side(WHITE)
  , xside(BLACK)
  , castle(0)
  , ep(NOSQ)
  , fifty(0)
  , hash(0)
  , ply(0)
  , hply(0)
{
    side = old.side;
    xside = old.xside;
    castle = old.castle;
    ep = old.ep;
    fifty = old.fifty;
    hash = old.hash;
    ply = old.ply;
    hply = old.hply;
    std::copy(old.piece,old.piece+64,piece);
    std::copy(old.color,old.color+64,color);
    std::copy(old.gen_dat,old.gen_dat+GEN_STACK, gen_dat);
    std::copy(old.first_move,old.first_move+MAX_PLY, first_move);
    std::copy(old.hist_dat,old.hist_dat+HIST_STACK,hist_dat);
}

State &State::operator=(const State &src)
{
    if (this != &src)
    {
        side = src.side;
        xside = src.xside;
        castle = src.castle;
        ep = src.ep;
        fifty = src.fifty;
        hash = src.hash;
        ply = src.ply;
        hply = src.hply;
        std::copy(src.piece,src.piece+64,piece);
        std::copy(src.color,src.color+64,color);
        std::copy(src.gen_dat,src.gen_dat+GEN_STACK, gen_dat);
        std::copy(src.first_move,src.first_move+MAX_PLY, first_move);
        std::copy(src.hist_dat,src.hist_dat+HIST_STACK,hist_dat);
    }

    return *this;
}

